"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = coinSelect;

var _accumulative = _interopRequireDefault(require("./inputs/accumulative"));

var _bnb = _interopRequireDefault(require("./inputs/bnb"));

var sorts = _interopRequireWildcard(require("./sorts"));

var utils = _interopRequireWildcard(require("./utils"));

var _tryconfirmed = _interopRequireDefault(require("./tryconfirmed"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// I am using coinselect like this; the end-goal is, however, to merge all the changes
// back into the upstream and use coinselect from npm
function coinSelect(inputs, outputs, feeRate, options) {
  var sortedInputs = options.skipPermutation ? inputs : inputs.sort(sorts.score(feeRate));
  var algorithm = (0, _tryconfirmed["default"])(utils.anyOf([(0, _bnb["default"])(0.5), _accumulative["default"]]), options);
  return algorithm(sortedInputs, outputs, feeRate, options);
}